/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.YYLogger
 *  fire.log.beans.OpPetMixBean
 *  fire.pb.common.SCommon
 *  fire.pb.course.CourseManager
 *  fire.pb.item.ItemBase
 *  fire.pb.item.PETEQUIP
 *  fire.pb.main.ConfigManager
 *  fire.pb.talk.MessageMgr
 *  fire.pb.tel.utils.GoodsSafeLocksUtils
 *  fire.pb.util.Misc
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.PetInfo
 *  xbean.PetSkill
 *  xtable.Properties
 */
package fire.pb.pet;

import fire.log.YYLogger;
import fire.log.beans.OpPetMixBean;
import fire.pb.common.SCommon;
import fire.pb.course.CourseManager;
import fire.pb.item.ItemBase;
import fire.pb.item.PETEQUIP;
import fire.pb.main.ConfigManager;
import fire.pb.pet.CalcPetAttr;
import fire.pb.pet.Helper;
import fire.pb.pet.Module;
import fire.pb.pet.Pet;
import fire.pb.pet.PetAttr;
import fire.pb.pet.PetColumn;
import fire.pb.pet.PetSynthesizeSkillRateConfig;
import fire.pb.pet.SPetSynthesize;
import fire.pb.pet.SkillRate;
import fire.pb.talk.MessageMgr;
import fire.pb.tel.utils.GoodsSafeLocksUtils;
import fire.pb.util.Misc;
import java.util.ArrayList;
import java.util.List;
import java.util.TreeMap;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.PetInfo;
import xbean.PetSkill;
import xtable.Properties;

public class PPetSynthesizeProc
extends Procedure {
    private final long roleId;
    private final int petKey1;
    private final int petKey2;

    public PPetSynthesizeProc(long roleId, int petKey1, int petKey2) {
        this.roleId = roleId;
        this.petKey1 = petKey1;
        this.petKey2 = petKey2;
    }

    public boolean process() {
        Integer curLevel = Properties.selectLevel((Long)this.roleId);
        if (curLevel == null) {
            return false;
        }
        if (curLevel < 55) {
            return false;
        }
        Integer fightPetKey = Properties.selectFightpetkey((Long)this.roleId);
        if (fightPetKey == this.petKey1 || fightPetKey == this.petKey2) {
            return false;
        }
        PetColumn petCol = new PetColumn(this.roleId, 1, false);
        Pet pet1 = petCol.getPet(this.petKey1);
        Pet pet2 = petCol.getPet(this.petKey2);
        if (pet1 == null || pet2 == null) {
            return false;
        }
        if (this.isHaveSkillCertification(pet1) || this.isHaveSkillCertification(pet2)) {
            return false;
        }
        long petkey1 = this.roleId + (long)pet1.getPetkey();
        PETEQUIP equip1 = new PETEQUIP(this.roleId, false, petkey1);
        long petkey2 = this.roleId + (long)pet2.getPetkey();
        PETEQUIP equip2 = new PETEQUIP(this.roleId, false, petkey2);
        int i = 0;
        for (ItemBase itemBase : equip1) {
            ++i;
        }
        for (ItemBase itemBase : equip2) {
            ++i;
        }
        if (i > 0) {
            MessageMgr.psendMsgNotify((long)this.roleId, (int)198049, null);
            return false;
        }
        PetInfo newPetInfo = this.newPetInfoBySynthesize(pet1, pet2);
        if (newPetInfo != null) {
            if (petCol.removePet(pet1.getPetkey(), 5) != 0) {
                return false;
            }
            if (petCol.removePet(pet2.getPetkey(), 5) != 0) {
                return false;
            }
            if (petCol.add(newPetInfo, 8) <= 0) {
                return false;
            }
            Procedure.psendWhileCommit((long)this.roleId, (Protocol)new SPetSynthesize(newPetInfo.getKey()));
            Pet newpet = Pet.getPet(newPetInfo);
            newpet.updatePetScoreWhileChange();
            CourseManager.achieveUpdate((long)this.roleId, (int)41);
            CourseManager.checkAchieveCourse((long)this.roleId, (int)44, (int)newpet.getBattleskillIds().size());
            CourseManager.checkAchieveCourse((long)this.roleId, (int)31, (int)newpet.getPetInfo().getPetscore());
            if (Module.logger.isInfoEnabled()) {
                Module.logger.info((Object)("[PPetSynthesizeProc] roleId:" + this.roleId + " petInfo1:" + Helper.toString(pet1.getPetInfo()) + " petInfo2:" + Helper.toString(pet2.getPetInfo()) + " newPetInfo:" + Helper.toString(newPetInfo)));
            }
            this.writeYYLogger(pet1, pet2, newPetInfo, newpet);
            GoodsSafeLocksUtils.doClearDataWhileCommit((long)this.roleId);
        }
        return true;
    }

    private void writeYYLogger(Pet pet1, Pet pet2, PetInfo newPetInfo, Pet newpet) {
        if (pet1 == null || pet2 == null || newPetInfo == null || newpet == null) {
            return;
        }
        OpPetMixBean opPetMixBean = new OpPetMixBean(pet1.getPetAttr().getId(), pet1.getPetAttr().getTreasureScore() > pet1.getPetInfo().getPetscore() ? 0 : 1, pet2.getPetAttr().getId(), pet2.getPetAttr().getTreasureScore() > pet2.getPetInfo().getPetscore() ? 0 : 1, newPetInfo.getId(), newpet.getPetAttr().getTreasureScore() > newPetInfo.getPetscore() ? 0 : 1);
        YYLogger.petMixLog((long)this.roleId, (OpPetMixBean)opPetMixBean);
    }

    public boolean isHaveSkillCertification(Pet pet) {
        List<PetSkill> skills = pet.getBattleskills();
        for (PetSkill s : skills) {
            if (s.getCertification() != 1) continue;
            return true;
        }
        return false;
    }

    public List<Integer> getSkillList(int newID, Pet pet1, Pet pet2) {
        PetAttr attr;
        ArrayList<Integer> skillIds = new ArrayList<Integer>();
        if (newID == pet1.getBaseId()) {
            attr = Module.getInstance().getPetManager().getAttr(pet1.getBaseId());
            for (SkillRate sr : attr.getSkills()) {
                if (sr.rate < 1001) continue;
                skillIds.add(sr.getSkillid());
            }
        } else {
            attr = Module.getInstance().getPetManager().getAttr(pet2.getBaseId());
            for (SkillRate sr : attr.getSkills()) {
                if (sr.rate < 1001) continue;
                skillIds.add(sr.getSkillid());
            }
        }
        List<Integer> randomSkillIds = pet1.getBattleskillIds();
        for (Integer id : pet2.getBattleskillIds()) {
            if (randomSkillIds.contains(id)) continue;
            randomSkillIds.add(id);
        }
        for (Integer id : skillIds) {
            while (randomSkillIds.contains(id)) {
                randomSkillIds.remove(id);
            }
        }
        TreeMap confs = ConfigManager.getInstance().getConf(PetSynthesizeSkillRateConfig.class);
        if (confs != null) {
            int sumValue = 0;
            for (int i = 0; i <= randomSkillIds.size(); ++i) {
                PetSynthesizeSkillRateConfig conf = (PetSynthesizeSkillRateConfig)confs.get(i);
                if (conf == null) continue;
                sumValue += conf.getValue();
            }
            int r = Misc.getRandomBetween((int)1, (int)sumValue);
            int curValue = 0;
            for (int num = 0; num <= randomSkillIds.size(); ++num) {
                PetSynthesizeSkillRateConfig conf = (PetSynthesizeSkillRateConfig)confs.get(num);
                if (conf == null || (curValue += conf.getValue()) < r) continue;
                for (int n = 0; n < num; ++n) {
                    int index = Misc.getRandomBetween((int)0, (int)(randomSkillIds.size() - 1));
                    int id = randomSkillIds.get(index);
                    skillIds.add(id);
                    randomSkillIds.remove(index);
                }
                break;
            }
        }
        return skillIds;
    }

    static Double getCommonConf(int id) {
        SCommon conf;
        TreeMap confs = ConfigManager.getInstance().getConf(SCommon.class);
        if (confs != null && (conf = (SCommon)confs.get(id)) != null) {
            return Double.parseDouble(conf.getValue());
        }
        return null;
    }

    public double getAptFactorMinConf() {
        Double p = PPetSynthesizeProc.getCommonConf(102);
        if (p == null) {
            p = 0.9;
        }
        return p;
    }

    public double getAptFactorMaxConf() {
        Double p = PPetSynthesizeProc.getCommonConf(103);
        if (p == null) {
            p = 1.08;
        }
        return p;
    }

    public int randomAptitude(int v1, int v2) {
        double p1 = this.getAptFactorMinConf();
        double p2 = this.getAptFactorMaxConf();
        int min = (int)((double)(v1 + v2) / 2.0 * p1);
        int max = (int)((double)(v1 + v2) / 2.0 * p2);
        return Misc.getRandomBetween((int)min, (int)max);
    }

    public int getAptitudeMax(Pet pet1, Pet pet2, int maxValue1, int maxValue2) {
        if (pet1.getKind() == 3 || pet2.getKind() == 3) {
            double aptFactorMax = this.getAptFactorMaxConf();
            if (pet1.getKind() == 2) {
                maxValue1 = (int)((double)maxValue1 * aptFactorMax);
            } else if (pet2.getKind() == 2) {
                maxValue2 = (int)((double)maxValue2 * aptFactorMax);
            }
        }
        return Math.max(maxValue1, maxValue2);
    }

    public int fixAptitudeValue(Pet pet1, Pet pet2, int value, int aptId) {
        if (pet1.getKind() == 3 || pet2.getKind() == 3) {
            int maxValue = -1;
            switch (aptId) {
                case 1440: {
                    maxValue = this.getAptitudeMax(pet1, pet2, pet1.getPetAttr().getAttackaptmax(), pet2.getPetAttr().getAttackaptmax());
                    break;
                }
                case 1450: {
                    maxValue = this.getAptitudeMax(pet1, pet2, pet1.getPetAttr().getDefendaptmax(), pet2.getPetAttr().getDefendaptmax());
                    break;
                }
                case 1470: {
                    maxValue = this.getAptitudeMax(pet1, pet2, pet1.getPetAttr().getMagicaptmax(), pet2.getPetAttr().getMagicaptmax());
                    break;
                }
                case 1460: {
                    maxValue = this.getAptitudeMax(pet1, pet2, pet1.getPetAttr().getPhyforceaptmax(), pet2.getPetAttr().getPhyforceaptmax());
                    break;
                }
                case 1490: {
                    maxValue = this.getAptitudeMax(pet1, pet2, 0, 0);
                    break;
                }
                case 1480: {
                    maxValue = this.getAptitudeMax(pet1, pet2, pet1.getPetAttr().getSpeedaptmax(), pet2.getPetAttr().getSpeedaptmax());
                    break;
                }
                default: {
                    Module.logger.error((Object)("[PPetSynthesizeProc.fixAptitudeValue] roleId:" + this.roleId + " apt:" + aptId));
                    return 0;
                }
            }
            value = Math.min(value, maxValue);
        }
        return value;
    }

    public int randomGrowrate(int v1, int v2) {
        Double p1 = PPetSynthesizeProc.getCommonConf(104);
        Double p2 = PPetSynthesizeProc.getCommonConf(105);
        if (p1 == null) {
            p1 = 48.0;
        }
        if (p2 == null) {
            p2 = 24.0;
        }
        int min = (int)((double)(v1 + v2) / 2.0 - p1);
        int max = (int)((double)(v1 + v2) / 2.0 + p2);
        return Misc.getRandomBetween((int)min, (int)max);
    }

    public PetInfo newPetInfoBySynthesize(Pet pet1, Pet pet2) {
        int newID = Misc.getRatePercent() <= 50 ? pet1.getBaseId() : pet2.getBaseId();
        int kind = newID == pet1.getBaseId() ? pet1.getKind() : pet2.getKind();
        int newLevel = Misc.getRandomBetween((int)pet1.getLevel(), (int)pet2.getLevel());
        List<Integer> skillIds = this.getSkillList(newID, pet1, pet2);
        PetInfo newPetInfo = PetColumn.createPet(this.roleId, newID, newLevel, skillIds, kind, 1, false);
        int attackApt = this.randomAptitude(pet1.getAttackapt(), pet2.getAttackapt());
        attackApt = this.fixAptitudeValue(pet1, pet2, attackApt, 1440);
        int defendApt = this.randomAptitude(pet1.getDefendapt(), pet2.getDefendapt());
        defendApt = this.fixAptitudeValue(pet1, pet2, defendApt, 1450);
        int magicApt = this.randomAptitude(pet1.getMagicapt(), pet2.getMagicapt());
        magicApt = this.fixAptitudeValue(pet1, pet2, magicApt, 1470);
        int phyforceApt = this.randomAptitude(pet1.getPhyforceapt(), pet2.getPhyforceapt());
        phyforceApt = this.fixAptitudeValue(pet1, pet2, phyforceApt, 1460);
        int dodgeApt = this.randomAptitude(pet1.getDodgeapt(), pet2.getDodgeapt());
        dodgeApt = this.fixAptitudeValue(pet1, pet2, dodgeApt, 1490);
        int speedApt = this.randomAptitude(pet1.getSpeedapt(), pet2.getSpeedapt());
        speedApt = this.fixAptitudeValue(pet1, pet2, speedApt, 1480);
        CalcPetAttr cattr = new CalcPetAttr(newPetInfo);
        cattr.setBornAttackApt(attackApt);
        cattr.setBornDefendApt(defendApt);
        cattr.setBornMagicApt(magicApt);
        cattr.setBornPhyforceApt(phyforceApt);
        cattr.setBornDodgeApt(dodgeApt);
        cattr.setBornSpeedApt(speedApt);
        int growrate = this.randomGrowrate(pet1.getGrowrate(), pet2.getGrowrate());
        newPetInfo.setGrowrate(growrate);
        newPetInfo.setAutoaddcons(0);
        newPetInfo.setAutoaddiq(0);
        newPetInfo.setAutoaddstr(0);
        newPetInfo.setAutoaddendu(0);
        newPetInfo.setAutoaddagi(0);
        return newPetInfo;
    }
}

